{                                COUNTERS

Auteur : Bacterius.

Utilisez les fonctions suivantes pour insrer un ou plusieurs compteurs dans votre application.

Ce qu'il faut bien comprendre dans ce compteur, c'est qu'il possde deux tats implicites :
  - l'tat "comptant", o il contient les valeurs de dpart de l'horloge, qui sont inutilisables.
  - l'tat "compt", o il contient les valeurs exactes de temps entre le dpart et la fin.

Les diffrentes fonctions font basculer un compteur dans un de ces tats, voici ces tats :
InitializeCounter : Passe en comptant.
ResetCounter      : Passe en comptant.
ChangePrecision   : Passe en comptant.
QueryCounter      : Passe en compt.
ReleaseCounter    : N/A.

Ainsi, vous ne pourrez utiliser les valeurs du compteur que aprs un appel  QueryCounter.
Attention : QueryCounter ne modifie PAS la valeur du compteur, il renvoie la diffrence de temps
entre l'appel  ResetCounter et entre l'appel  QueryCounter.

L'ordre normal des appels aux fonctions serait alors :

1. InitializeCounter
2. QueryCounter      | Effectuer le 2. et le 3. autant de fois que ncessaire.
3. ResetCounter      | Eventuellement glisser un SwitchMode  la place du 3.
4. ReleaseCounter


Remarques :

 Le compteur calcule ses temps sur les temps de l'horloge haute prcision, les temps
sont donc en virgule flottante (comme 454.56 ms, 72837.12 s ...). En revanche, si vous
ne possdez pas d'horloge haute prcision, toutes les prcisions au-dessus de 1000 donneront 0
et pour la prcision 1000 et infrieur (milliseconde et infrieur), QueryCounter
renverra un nombre entier. Pour savoir si vous possdez cette horloge, vrifiez que
QueryPerformanceCounter renvoie True (ou bien vrifiez que HighResFound de cette
unit est bien  True, puisqu'elle se base sur le rsultat de QueryPerformanceCounter).

 Vous pouvez utiliser un type PCounter ou bien un type Pointer pour utiliser le compteur.
Il est plus sr d'utiliser un type Pointer car cela empchera des modifications non dsires
de la valeur ou de la prcision du compteur, et vous devrez utiliser GetCounterPrecision pour
rcuprer la prcision du compteur. Si vous utilisez PCounter, vous pouvez directement accder
aux champs du compteur, mais ne les modifiez pas directement, utilisez les fonctions prvues 
cet effet.

 Vous pouvez maintenant utiliser la classe TCounter si vous prfrez manipuler des objets.

}

unit Counters;

interface

uses Windows, SysUtils;

const                           { Des constantes pour savoir ce que le compteur gre }
  SECONDS      = 1;             { Le compteur gre les secondes      }
  MILLISECONDS = 1000;          { Le compteur gre les millisecondes }
  MICROSECONDS = 1000000;       { Le compteur gre les microsecondes }
  NANOSECONDS  = 1000000000;    { Le compteur gre les nanosecondes  }

type
  _COUNTER = record { Un compteur - le type objet ne sera pas utilis }
   Precision: Longword;  { La prcision du compteur (1 : secondes, 1000 : ms, 1000000 : s }
   Value: Extended;      { La valeur actuelle du compteur en millisecondes ou en microsecondes }
  end;

  PCounter = ^_COUNTER;  { Un pointeur sur un compteur : sera utilis dans les fonctions }

{ InitializeCounter va crer un compteur, et appeller ensuite ChangePrecision (qui appelle ResetCounter) }
function InitializeCounter(Precision: Longword): PCounter;
{ ResetCounter va redfinir les valeurs du compteur  l'horloge actuelle }
function ResetCounter(Counter: PCounter): Boolean;
{ ChangePrecision permet de changer le mode d'un compteur, puis appeller ResetCounter }
function ChangePrecision(Counter: PCounter; NewPrec: Longword): Boolean;
{ QueryCounter va mettre  jour les valeurs du compteur }
function QueryCounter(Counter: PCounter): Extended;
{ Renvoie la prcision du compteur - utile si l'on utilise un type Pointer pour le compteur }
function GetCounterPrecision(Counter: PCounter): Longword;
{ ReleaseCounter va librer un compteur cr avec InitializeCounter }
function ReleaseCounter(Counter: PCounter): Boolean;

type
 TCounter = class                                            { Classe TCounter }
 private
  FCounter: PCounter;                                        { Champ objet pour le compteur }
  function GetValue: Extended;                               { Rcupration de la valeur du compteur }
  function GetPrecision: Longword;                           { Rcupration de la prec. du compteur }
  procedure SetPrecision(Value: Longword);                   { Dfinition de la prec. du compteur }
 public
  constructor Create(Precision: Longword); reintroduce;      { Cration de TCounter }
  destructor Destroy; override;                              { Destruction de TCounter }
  procedure Reset;                                           { Remise  0 du compteur }
  property Value: Extended    read GetValue;                 { Proprit Value        }
  property Precision: Longword read GetPrecision write SetPrecision; { Proprit Precision }
 end;

Var
 HighResFound: Boolean;
 Tmp: PInt64;

implementation

function GetTckCount(Precision: Longword): Extended; { Rcupre le temps de l'horloge }
Var
 Freq, Bgn: Int64;                 
begin
 if not HighResFound then
  begin
   { En dessous de millisecondes non disponible }
   Result := 0;
   if Precision <= 1000 then Result := GetTickCount div Abs(Precision - 999);
   Exit;                          { On s'en va }
  end;

 QueryPerformanceFrequency(Freq); { On rcupre la frquence de l'horloge }
 QueryPerformanceCounter(Bgn);    { On rcupre le temps actuel           }
 Result := Bgn * Precision / Freq;  { On le formate pour obtenir le temps en microsecondes }
end;

{ InitializeCounter cre un compteur, puis appelle ResetCounter avec le mode spcifi }
function InitializeCounter(Precision: Longword): PCounter;
begin
 New(Result);                        { Cration du pointeur vers le compteur }
 ChangePrecision(Result, Precision); { Appelle SwitchMode pour dfinir la prcision du compteur }
end;

{ ResetCounter va basculer le compteur en mode comptant }
function ResetCounter(Counter: PCounter): Boolean;
begin
 Result := Assigned(Counter);    { On vrifie que le compteur soit bien initialis }

 if Result then                  { Si il l'est ... }
  with Counter^ do
   Value := GetTckCount(Precision); { On remet la valeur de l'horloge }
end;

{ ChangePrecision va modifier le mode d'un compteur et appeller ResetCounter ensuite }
function ChangePrecision(Counter: PCounter; NewPrec: Longword): Boolean;
begin
 Result := False;

 if Assigned(Counter) then      { On vrifie que le compteur soit initialis }
  begin
   if NewPrec = Counter.Precision then Exit; { Si on ne change pas de prcision, on s'en va direct }
   Counter.Precision := NewPrec;            { On modifie le mode }
   Result := ResetCounter(Counter);          { Puis on appelle ResetCounter }
  end;
end;

{ QueryCounter va faire basculer le compteur en mode compt. Vous pourrez alors utiliser ses
  valeurs selon l'unit de temps choisie (ms ou s ). }
function QueryCounter(Counter: PCounter): Extended;
begin
 Result := 0;                                      { Valeur  0, en cas de problme }

 if Assigned(Counter) then                         { Si le compteur est bien initialis ... }
  with Counter^ do
   Result := GetTckCount(Precision) - Value;       { On calcule le temps coul }                                           { ... depuis l'appel  ResetCounter }
end;

{ Renvoie la prcision du compteur - utile si l'on utilise un type Pointer pour le compteur }
function GetCounterPrecision(Counter: PCounter): Longword;
begin
 Result := High(Longword);                         { Rsultat non valable pour commencer }
 if Assigned(Counter) then Result := Counter.Precision; { On rcupre le mode du compteur }
end;

{ ReleaseCounter va librer un compteur cr avec InitializeCounter}
function ReleaseCounter(Counter: PCounter): Boolean;
begin
 Result := Assigned(Counter);          { On vrifie que le compteur soit bien initialis }
 if Result then Dispose(Counter);      { Le cas chant, on le libre }
end;







{-------------------------------- TCOUNTER ------------------------------------}

constructor TCounter.Create(Precision: Longword); { Cration du TCounter }
begin
 inherited Create;                                { On cre l'objet }
 FCounter := InitializeCounter(Precision);        { On initialise le compteur }
end;

destructor TCounter.Destroy;                      { Destruction du TCounter }
begin
 ReleaseCounter(FCounter);                        { On libre le compteur }
 inherited Destroy;                               { On dtruit l'objet }
end;

procedure TCounter.Reset;                         { Remise  0 du compteur }
begin
 ResetCounter(FCounter);                          { On remet  0           }
end;

function TCounter.GetValue: Extended;             { Rcupration de la valeur du compteur }
begin
 Result := QueryCounter(FCounter);                { On rcupre avec QueryCounter }
end;

function TCounter.GetPrecision: Longword;         { Rcupration du mode du compteur }
begin
 Result := GetCounterPrecision(FCounter);         { On rcupre avec GetCounterPrecision }
end;

procedure TCounter.SetPrecision(Value: Longword); { Dfinition du mode du compteur }
begin
 ChangePrecision(FCounter, Value);
 { On change avec ChangePrecision. Pas besoin de vrifier si l'on met une precision diffrente, la
 fonction s'en occupe ! }
end;





initialization
  New(Tmp);
  HighResFound := QueryPerformanceCounter(Tmp^);
  Dispose(Tmp);
  { Si QueryPerformanceCounter renvoie True, vous pourrez utiliser toutes les fonctions du compteur.
    Sinon, vous ne pourrez pas utiliser les trs petites prcisions et vous aurez une prcision
    moindre sur les millisecondes.
    Mais rassurez-vous, de nos jours tous les PC ont des horloges haute prcision ! :p       }

end.
