unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, LEA, ComCtrls, ExtCtrls, StdCtrls, jpeg, MarqueeBar, Counters,
  Gauges;

type
  TMainForm = class(TForm)
    Pages: TPageControl;
    WelcomeSheet: TTabSheet;
    PasswordSheet: TTabSheet;
    WelcomePanel: TPanel;
    ProgImg: TImage;
    WelcomeLbl: TLabel;
    WelcomeLbl2: TLabel;
    PasswordLbl: TLabel;
    PasswordLbl2: TLabel;
    PasswordEdit: TEdit;
    PasswordLbl3: TLabel;
    PasswordEdit2: TEdit;
    PasswordHeader: TLabel;
    PasswordSep: TBevel;
    BruteforceSheet: TTabSheet;
    BruteHeader: TLabel;
    BruteSep: TBevel;
    BruteLbl: TLabel;
    BruteLbl2: TLabel;
    BruteEdit: TEdit;
    BruteBtn: TButton;
    BruteBar: TProgressBar;
    FileSheet: TTabSheet;
    FileHeader: TLabel;
    FileLbl: TLabel;
    FileSep: TBevel;
    FileBtn: TButton;
    FileEdit: TEdit;
    FileLbl3: TLabel;
    OpenDlg: TOpenDialog;
    CollSheet: TTabSheet;
    PerfSheet: TTabSheet;
    PerfHeader: TLabel;
    PerfSep: TBevel;
    PerfLbl: TLabel;
    PerfLbl2: TLabel;
    PerfLbl3: TLabel;
    PerfLbl4: TLabel;
    PerfLbl5: TLabel;
    PerfBtn: TButton;
    CollHeader: TLabel;
    CollSep: TBevel;
    CollLbl: TLabel;
    CollLbl2: TLabel;
    CollEdit: TEdit;
    CollBtn: TButton;
    CollBar: TProgressBar;
    FileBar: TGauge;
    procedure FormCreate(Sender: TObject);
    procedure PasswordEditChange(Sender: TObject);
    procedure BruteBtnClick(Sender: TObject);
    procedure BruteEditChange(Sender: TObject);
    procedure FileBtnClick(Sender: TObject);
    procedure PerfBtnClick(Sender: TObject);
    procedure CollEditChange(Sender: TObject);
    procedure CollBtnClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure Search(S: String; Depth, MaxDepth: Integer);
    function CollisionTest(Depth: Int64): Int64;
  end;

var
  MainForm: TMainForm;
  H: THash;
  Found, Stop, Stop2: Boolean;

implementation

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
Var
 I: Integer;
begin
 DoubleBuffered := True;
 Pages.DoubleBuffered := True;
 for I := 0 to Pages.ControlCount - 1 do
  if Pages.Controls[I] is TTabSheet then TTabSheet(Pages.Controls[I]).DoubleBuffered := True;
 WelcomePanel.DoubleBuffered := True;
 PasswordEditChange(self);
 PerfBtnClick(self);
 BruteBar.DoubleBuffered := True;
 CollBar.DoubleBuffered := True;
end;

procedure TMainForm.PasswordEditChange(Sender: TObject);
begin
 PasswordEdit2.Text := String(HashToString(HashStr(AnsiString(PasswordEdit.Text))));
end;

procedure TMainForm.Search(S: String; Depth, MaxDepth: Integer);
Var
 I: Integer;
begin
 Application.ProcessMessages;
 if (Found) or (Stop) then Exit;

 if SameHash(H, HashStr(S)) then
  begin
   Found := True;
   BruteBar.Active := False;
   MessageDlg('Le mot de passe a t trouv. Il s''agit de "' + S + '".', mtInformation, [mbOK], 0);
   BruteBtn.Caption := 'Lancer le brute-force';
   BruteBtn.Tag := 0;
   Exit;
  end;

  for I := 48 to 122 do
   begin
    if (I in [58..64, 91..96]) then Continue;

    if SameHash(H, HashStr(AnsiString(S + chr(I)))) then
     begin
      Found := True;
      BruteBar.Active := False;
      MessageDlg('Le mot de passe a t trouv. Il s''agit de "' + S + chr(I) + '".', mtInformation, [mbOK], 0);
      BruteBtn.Caption := 'Lancer le brute-force';
      BruteBtn.Tag := 0;
      Exit;
     end;
   end;

 for I := 48 to 122 do
  begin
   if (I in [58..64, 91..96]) then Continue;
   if Depth < MaxDepth then Search(S + chr(I), Depth + 1, MaxDepth);
  end;
end;

procedure TMainForm.BruteBtnClick(Sender: TObject);
Var
 I: Integer;
begin
 case BruteBtn.Tag of
  0:
   begin
    if not IsHash(BruteEdit.Text) then
      raise Exception.Create('Le hash propos n''est pas correct.');

    BruteBtn.Caption := 'Brute-force en cours. Cliquez pour arrter.';
    BruteBtn.Tag := 1;
    Stop := False;
    Found := False;
    H := StringToHash(AnsiString(BruteEdit.Text));
    BruteBar.Active := True;
    for I := 1 to 10 do Search('', 0, I);
    if (not Found) and (not Stop) then MessageDlg('Le mot de passe n''a pas t trouv.', mtInformation, [mbOK], 0);
    BruteBtn.Caption := 'Lancer le brute-force';
    BruteBtn.Tag := 0;
    BruteBar.Active := False;
   end;
  1:
   begin
    Stop := True;
    BruteBtn.Caption := 'Lancer le brute-force';
    BruteBtn.Tag := 0;
    BruteBar.Active := False;
   end;
 end;
end;

procedure TMainForm.BruteEditChange(Sender: TObject);
begin
 case IsHash(AnsiString(BruteEdit.Text)) of
  False: BruteEdit.Font.Color := clRed;
  True: BruteEdit.Font.Color := clGreen;
 end;
end;

procedure Callback(Index, Count: Longword); stdcall;
begin
 if Index mod 32768 <> 0 then Exit;
 MainForm.FileBar.MaxValue := Pred(Count);
 MainForm.FileBar.Progress := Index;
 Application.ProcessMessages;
end;

procedure TMainForm.FileBtnClick(Sender: TObject);
begin
 if OpenDlg.Execute then
  begin
   if not FileExists(OpenDlg.FileName) then raise Exception.Create('Le fichier n''existe pas.');
   FileBtn.Enabled := False;
   FileEdit.Text := 'Calcul en cours ...';
   FileEdit.Text := String(HashToString(HashFile(AnsiString(OpenDlg.FileName), Callback)));
   FileBtn.Enabled := True;
   Filebar.Progress := 0;
  end;
end;

procedure TMainForm.PerfBtnClick(Sender: TObject);
Var
 Counter: TCounter;
 Perfs: array [0..3] of Extended;
 Buf: array [0..16383] of Byte;
begin
 Counter := TCounter.Create(MICROSECONDS);
 HashStr('0123456789ABCDEF');
 Perfs[0] := Counter.Value;
 Counter.Reset;
 Hash(Buf, 16384);
 Perfs[1] := Counter.Value;
 Counter.Reset;
 HashFile(Application.ExeName);
 Perfs[2] := Counter.Value;
 Perfs[3] := 0;
 Counter.Reset;
 repeat
  HashStr(AnsiString('0123456789'));
  Perfs[3] := Perfs[3] + 1;
 until Counter.Value >= 1000000;

 Counter.Free;

 PerfLbl.Caption := Format('Hash (d''une donne de 16 octets) : %.2f s.', [Perfs[0]]);
 PerfLbl2.Caption := Format('Hash (d''une donne de 16 kilooctets) : %.2f s.', [Perfs[1]]);
 PerfLbl3.Caption := Format('Hash (d''une donne de 568 kilooctets) : %.2f ms.', [Perfs[2] / 1000]);
 PerfLbl4.Caption := Format('Mots de passe hashs par seconde : %d.', [Round(Perfs[3])]);
end;

procedure TMainForm.CollEditChange(Sender: TObject);
begin
 if StrToInt64Def(CollEdit.Text, 0) > 0 then CollEdit.Font.Color := clGreen else CollEdit.Font.Color := clRed;
end;

function TMainForm.CollisionTest(Depth: Int64): Int64;
Var
 S: ShortString;
 List: TStringList;
 I: Integer;
begin
 Result := 0;
 List := TStringList.Create;
 List.BeginUpdate;
 try
  S := HashToString(HashStr(''));
  List.Add(S);
  I := 0;
  while I < Depth do
   begin
    if Stop2 then Break;
    Inc(I);
    S := HashToString(HashStr(S));
    List.Add(S);
    Application.ProcessMessages;
   end;

 List.Sort;

 I := 0;
 while I < List.Count - 1 do
  begin
   if List.Strings[I + 1] = List.Strings[I] then Inc(Result);
   Inc(I);
   Application.ProcessMessages;
  end;

 finally
  List.EndUpdate;
  List.Free;
 end;
end;

procedure TMainForm.CollBtnClick(Sender: TObject);
Var
 Res: Int64;
begin
 case CollBtn.Tag of
  0:
   begin
    if CollEdit.Font.Color = clRed then
     raise Exception.Create('Veuillez saisir un nombre positif correct pour le nombre d''itrations du test.');

    CollBtn.Tag := 1;
    CollBtn.Caption := 'Arrter de test de collisions.';
    CollBar.Active := True;
    Stop2 := False;
    Res := CollisionTest(StrToInt64(CollEdit.Text));
    CollBar.Active := False;
    if Res > 0 then MessageDlg('Le test de collisions est termin. ' + IntToStr(Res) + ' collisions ont t trouves.', mtInformation, [mbOK], 0);
    if Res = 0 then MessageDlg('Le test de collisions est termin. Aucune collision n''a t trouve.', mtInformation, [mbOK], 0);
    if Res < 0 then MessageDlg('Le test de collisions a t interrompu. ' + IntToStr(-Res - 1) + ' collisions ont t trouves.', mtInformation, [mbOK], 0);

    CollBtn.Caption := 'Lancer le test de collisions';
    CollBtn.Tag := 0;
    Exit;
   end;
  1:
   begin
    Stop2 := True;
    CollBtn.Caption := 'Lancer le test de collisions';
    CollBtn.Tag := 0;
    CollBar.Active := False;
   end;
 end;
end;

end.
